#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=netshell_190.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Fileversion=0.3.0.20
#AutoIt3Wrapper_Res_Fileversion_AutoIncrement=y
#AutoIt3Wrapper_Res_Icon_Add=netshell_193.ico
#AutoIt3Wrapper_Res_Icon_Add=netshell_191.ico
#AutoIt3Wrapper_Res_Icon_Add=netshell_192.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#comments-start

PPTPchek- Displays an icon in the SysTray while the specified PPTP connection exists

PPTPchek.exe [delay]

where: [delay]       = Optional delay before monitoring starts (in seconds)

eg.  PPTPchek.exe 30

Tray icon will  change colour at the end of the delay period, (if given or when rasdial.exe has finished), to indicate monitoring has begun.

NIC status will be checked every 5000 milliseconds.

PPTPchek can be terminated by causing the PPTP connection to disconnect, (eg. pull the cable), or choosing Exit from the icon context menu.

If the icon is flashing between its normal icon and a red cross it indicates the program is PAUSED - use the context menu to unpause.
#comments-end

#include <Constants.au3>
#include <StaticConstants.au3>

Opt("TrayAutoPause", 0)

TraySetState()                                                                   ; Show tray icon
If $CmdLine[0] > 1 Then
	If Int($CmdLine[2]) > 0 Then
		$j = 0
		$i = TimerInit()
		While $j < Int($CmdLine[2]) * 1000                          ; Loop until delay expired
			$j = TimerDiff($i)
			If ProcessExists("rasdial.exe") = 0 Then ExitLoop   ; If rasdial.exe process doesn't exist, exit the loop
			Sleep(1000)
		WEnd
	EndIf
EndIf
TraySetState(2)                                                                 ; Hides tray icon after delay
TraySetIcon(@ScriptName, -5)                                         ; Change icon
TraySetState(1)                                                                 ; Show tray icon, ie. monitoring starts

While 1
	If _GetState() = "" Then _Exit()
	Sleep(2000)
WEnd


Func _Exit()
	Exit
EndFunc


Func _GetState()
	While ProcessExists("rasdial.exe")
		Sleep(250)
	WEnd
	Local $foo = Run(@comspec & ' /c rasdial.exe', '.', @SW_HIDE, $STDOUT_CHILD)
	If @error Then
		MsgBox(48, "PPTPchek", "PPTPchek: Failed to run rasdial.exe")
	EndIf
	Local $output
	$output = ''
	While 1
		$output &= StdoutRead($foo)
	    If @error <> 0 Then ExitLoop
	WEnd
	StdioClose($foo)
	If StringInStr($output, "No connections") Then Return ""
	Local $temp = StringSplit($output, @CRLF)
	TraySetToolTip($temp[2])
	Return $temp[2]
EndFunc
